"use strict";

function _templateObject() {
  var data = _taggedTemplateLiteral(["", ""]);

  _templateObject = function _templateObject() {
    return data;
  };

  return data;
}

function _taggedTemplateLiteral(strings, raw) { if (!raw) { raw = strings.slice(0); } return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _styledComponents = _interopRequireDefault(require("styled-components"));

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _formik = require("formik");

var _rebass = require("rebass");

var _Flex = _interopRequireDefault(require("../../../Layout/Flex"));

var _Hint = _interopRequireDefault(require("../Hint"));

var _Label = _interopRequireDefault(require("../Label"));

var _Error = _interopRequireDefault(require("../Error"));

var _Input = _interopRequireDefault(require("../Input"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var displayName = 'Field';
var defaultProps = {
  component: _Input.default.Text,
  type: 'text'
};

var Field = function Field(_ref) {
  var component = _ref.component,
      hint = _ref.hint,
      label = _ref.label,
      name = _ref.name,
      placeholder = _ref.placeholder,
      type = _ref.type;
  return _react.default.createElement(_Flex.default, {
    flexDirection: "column",
    mb: 4
  }, _react.default.createElement(_StyledBox, {
    as: "label",
    htmlFor: name,
    mb: 2,
    order: 0,
    _css: {
      display: 'block'
    }
  }, _react.default.createElement(_Label.default, null, label), hint && _react.default.createElement(_Hint.default, null, hint), _react.default.createElement(_formik.ErrorMessage, {
    component: _Error.default,
    name: name
  })), _react.default.createElement(_rebass.Box, {
    order: 1
  }, _react.default.createElement(_formik.Field, {
    component: component,
    id: name,
    name: name,
    placeholder: placeholder,
    type: type
  })));
};

Field.displayName = displayName;
Field.defaultProps = defaultProps;
var _default = Field;
exports.default = _default;

var _StyledBox = (0, _styledComponents.default)(_rebass.Box)(_templateObject(), function (p) {
  return p._css;
});