"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _map2 = _interopRequireDefault(require("lodash/map"));

var _rebass = require("rebass");

var _Anchor = _interopRequireDefault(require("../../Anchor"));

var _List = _interopRequireDefault(require("../../List"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

var displayName = 'Summary';
var defaultProps = {};

var Summary =
/*#__PURE__*/
function (_React$PureComponent) {
  _inherits(Summary, _React$PureComponent);

  function Summary(props) {
    var _this;

    _classCallCheck(this, Summary);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(Summary).call(this, props));

    _this.focusTextInput = function () {
      _this.summary.current.focus();
    };

    _this.handleOnErrorClick = function (e) {
      e.preventDefault();
      var href = e.target.href;
      var id = href.substring(href.indexOf('#') + 1, href.length);
      document.getElementById(id).focus();
    };

    _this.id = "ErrorSummary";
    _this.summary = _react.default.createRef();
    return _this;
  }

  _createClass(Summary, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      this.focusTextInput();
    }
  }, {
    key: "render",
    value: function render() {
      var _this2 = this;

      return _react.default.createElement(_rebass.Box, {
        "aria-labelledby": "ErrorSummary-Heading-".concat(this.id),
        bg: "error",
        color: "errorInverse",
        id: this.id,
        mb: 4,
        p: 3,
        ref: this.summary,
        role: "group",
        tabIndex: "-1"
      }, _react.default.createElement(_rebass.Text, {
        as: "h4",
        color: "errorInverse",
        id: "ErrorSummary-Heading-".concat(this.id),
        mb: 2
      }, "Oops, there's a problem"), _react.default.createElement(_List.default, {
        size: "sm"
      }, (0, _map2.default)(this.props.errors, function (error, key) {
        return _react.default.createElement(_List.default.Item, {
          key: key
        }, _react.default.createElement(_Anchor.default, {
          color: "errorInverse",
          href: "#".concat(key),
          onClick: _this2.handleOnErrorClick,
          title: error
        }, error));
      })));
    }
  }]);

  return Summary;
}(_react.default.PureComponent);

Summary.displayName = displayName;
Summary.defaultProps = defaultProps;
var _default = Summary;
exports.default = _default;