"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _reactPopper = require("react-popper");

var _rebass = require("rebass");

var _PopoverContent = _interopRequireDefault(require("./PopoverContent"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

var defaultProps = {
  placement: 'bottom'
};

var Popover =
/*#__PURE__*/
function (_React$Component) {
  _inherits(Popover, _React$Component);

  function Popover(props) {
    var _this;

    _classCallCheck(this, Popover);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(Popover).call(this, props));

    _this.componentDidUpdate = function () {
      var _this$props = _this.props,
          onClose = _this$props.onClose,
          onOpen = _this$props.onOpen;
      var isOpen = _this.state.isOpen;
      if (isOpen && onOpen) onOpen();
      if (!isOpen && onClose) onClose();
    };

    _this.handleOnTargetClick = function () {
      _this.setState(function (state) {
        return {
          isOpen: !state.isOpen
        };
      });
    };

    _this.handleOnClose = function () {
      return _this.setState({
        isOpen: false
      });
    };

    _this.state = {
      isOpen: false
    };
    return _this;
  }

  _createClass(Popover, [{
    key: "render",
    value: function render() {
      var _this2 = this;

      return _react.default.createElement(_reactPopper.Manager, null, _react.default.createElement(_reactPopper.Reference, null, function (_ref) {
        var ref = _ref.ref;
        return _react.default.createElement(_rebass.Button, {
          onClick: _this2.handleOnTargetClick,
          ref: ref,
          variant: "plain"
        }, _this2.props.children[0]);
      }), _react.default.createElement(_reactPopper.Popper, {
        placement: this.props.placement,
        positionFixed: true
      }, function (_ref2) {
        var ref = _ref2.ref,
            style = _ref2.style,
            placement = _ref2.placement,
            arrowProps = _ref2.arrowProps,
            scheduleUpdate = _ref2.scheduleUpdate;
        return _react.default.createElement("div", {
          "data-placement": placement,
          ref: ref,
          style: style
        }, _this2.state.isOpen && _react.default.createElement(_PopoverContent.default, {
          closeOnClick: _this2.props.closeOnClick,
          closeOnClickOutside: _this2.props.closeOnClickOutside,
          closeOnEsc: _this2.props.closeOnEsc,
          onClose: _this2.handleOnClose,
          update: scheduleUpdate
        }, _this2.props.children[1], _react.default.createElement("div", {
          ref: arrowProps.ref,
          style: arrowProps.style
        })));
      }));
    }
  }]);

  return Popover;
}(_react.default.Component);

Popover.displayName = 'Popover';
Popover.defaultProps = defaultProps;
var _default = Popover;
exports.default = _default;