"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

var defaultProps = {
  closeOnClick: false,
  closeOnClickOutside: true,
  closeOnEsc: true
};

var PopoverContent =
/*#__PURE__*/
function (_React$PureComponent) {
  _inherits(PopoverContent, _React$PureComponent);

  function PopoverContent(props) {
    var _this;

    _classCallCheck(this, PopoverContent);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(PopoverContent).call(this, props));

    _this.componentWillUnmount = function () {
      _this.detachEvents();
    };

    _this.getContentDOM = function () {
      return _this.content && _this.content.current;
    };

    _this.attachEvents = function () {
      if (_this.props.closeOnClick) {
        document.addEventListener('click', _this.handleOnClickInside);
      }

      if (_this.props.closeOnClickOutside) {
        document.addEventListener('click', _this.handleClickOutside);
      }

      if (_this.props.closeOnEsc) {
        document.addEventListener('keydown', _this.handleCloseOnEscape);
      }
    };

    _this.detachEvents = function () {
      if (_this.props.closeOnClick) {
        document.removeEventListener('click', _this.handleOnClickInside);
      }

      if (_this.props.closeOnClickOutside) {
        document.removeEventListener('click', _this.handleClickOutside);
      }

      if (_this.props.closeOnEsc) {
        document.removeEventListener('keydown', _this.handleCloseOnEscape);
      }
    };

    _this.handleOnClickInside = function (event) {
      if (_this.getContentDOM().contains(event.target)) {
        _this.props.onClose();
      }
    };

    _this.handleClickOutside = function (event) {
      if (!_this.getContentDOM().contains(event.target)) {
        _this.props.onClose();
      }
    };

    _this.handleCloseOnEscape = function (event) {
      if (event.keyCode === 27) {
        _this.props.onClose();
      }
    };

    _this.content = _react.default.createRef();
    return _this;
  }

  _createClass(PopoverContent, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      this.attachEvents();
      this.props.update();
    }
  }, {
    key: "render",
    value: function render() {
      return _react.default.createElement("div", {
        ref: this.content
      }, this.props.children);
    }
  }]);

  return PopoverContent;
}(_react.default.PureComponent);

PopoverContent.displayName = 'PopoverContent';
PopoverContent.defaultProps = defaultProps;
var _default = PopoverContent;
exports.default = _default;