"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.getColorFromValue = exports.getInitials = void 0;

function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _nonIterableSpread(); }

function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance"); }

function _iterableToArray(iter) { if (Symbol.iterator in Object(iter) || Object.prototype.toString.call(iter) === "[object Arguments]") return Array.from(iter); }

function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = new Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } }

var getInitials = function getInitials(value) {
  return value.match(/\b(\w)/g).join('');
};

exports.getInitials = getInitials;

var stringAsciiCodeSum = function stringAsciiCodeSum(value) {
  return _toConsumableArray(value).map(function (letter) {
    return letter.charCodeAt(0);
  }).reduce(function (current, previous) {
    return previous + current;
  });
};

var getColorFromValue = function getColorFromValue(value, colors) {
  if (!value) return 'transparent';
  var sum = stringAsciiCodeSum(value);
  var index = sum % colors.length;
  return colors[index];
};

exports.getColorFromValue = getColorFromValue;